<template>
  <el-dialog
    :visible.sync="visible"
    :title="!dataForm.id ? $t('add') : $t('update')"
    :close-on-click-modal="false"
    :close-on-press-escape="false"
  >
    <el-form
      :model="dataForm"
      :rules="dataRule"
      ref="dataForm"
      @keyup.enter.native="dataFormSubmitHandle()"
      :label-width="$i18n.locale === 'en-US' ? '120px' : '80px'"
    >
      <el-form-item
        label="用户名"
        prop="username"
      >
        <el-input
          v-model="dataForm.username"
          placeholder="用户名"
        ></el-input>
      </el-form-item>
      <el-form-item
        label="手机号"
        prop="mobile"
      >
        <el-input
          v-model="dataForm.mobile"
          placeholder="手机号"
        ></el-input>
      </el-form-item>

      <el-form-item
        label="所属权限"
        prop="userRole"
      >
        <!--   <el-input v-model="dataForm.userRole" placeholder="案件ID"></el-input> -->
        <el-select
          style="width:100%"
          v-model="dataForm.userRole"
          placeholder="请选择所属权限"
          @change="selectChanged"
        >
          <el-option
            v-for="item in options"
            :key="item.name"
            :label="item.name"
            :value="item.name"
          >
          </el-option>
        </el-select>
      </el-form-item>

      <el-form-item
        label="身份证号"
        prop="userIdno"
      >
        <el-input
          v-model="dataForm.userIdno"
          placeholder="身份证号"
        ></el-input>
      </el-form-item>

    </el-form>
    <template slot="footer">
      <el-button @click="visible = false">{{ $t('cancel') }}</el-button>
      <el-button
        type="primary"
        @click="dataFormSubmitHandle()"
      >{{ $t('confirm') }}</el-button>
    </template>
  </el-dialog>
</template>

<script>
import debounce from "lodash/debounce";
export default {
  data() {
    return {
      visible: false,
      dataForm: {
        id: "",
        username: "",
        mobile: "",
        password: "",
        userIdno: "",
        userRole: "",
        /*  caseId: '', */
        createDate: "",
      },
      options: [],
    };
  },
  computed: {
    dataRule() {
      return {
        username: [
          {
            required: true,
            message: this.$t("validate.required"),
            trigger: "blur",
          },
        ],
        mobile: [
          {
            required: true,
            message: this.$t("validate.required"),
            trigger: "blur",
          },
        ],
        password: [
          {
            required: false,
            message: this.$t("validate.required"),
            trigger: "blur",
          },
        ],
        userIdno: [
          {
            required: false,
            message: this.$t("validate.required"),
            trigger: "blur",
          },
        ],
        userRole: [
          {
            required: true,
            message: this.$t("validate.required"),
            trigger: "blur",
          },
        ],
      };
    },
  },
  methods: {
    init() {
      this.visible = true;
      this.$nextTick(() => {
        this.$refs["dataForm"].resetFields();
        if (this.dataForm.id) {
          this.getInfo();
        }
        this.getAllRole();
      });
    },
    selectChanged(value) {
      this.options.forEach((ele) => {
        if (ele.name == value) {
          this.dataForm.userRoleId = ele.id;
        }
      });
    },
    // 获取信息
    getInfo() {
      this.$http
        .get(`/fhjw/user/${this.dataForm.id}`)
        .then(({ data: res }) => {
          if (res.code !== 0) {
            return this.$message.error(res.msg);
          }
          this.dataForm = {
            ...this.dataForm,
            ...res.data,
          };
        })
        .catch(() => {});
    },
    getAllRole() {
      this.$http
        .get("/fhjw/role/getAllRole")
        .then(({ data: res }) => {
          if (res.code !== 0) {
            return this.$message.error(res.msg);
          }
          this.options = res.data;
        })
        .catch(() => {});
    },
    // 表单提交
    dataFormSubmitHandle: debounce(
      function () {
        this.$refs["dataForm"].validate((valid) => {
          if (!valid) {
            return false;
          }
          console.log(this.dataForm);
          this.$http[!this.dataForm.id ? "post" : "put"](
            "/fhjw/user/",
            this.dataForm
          )
            .then(({ data: res }) => {
              if (res.code !== 0) {
                return this.$message.error(res.msg);
              }
              this.$message({
                message: this.$t("prompt.success"),
                type: "success",
                duration: 500,
                onClose: () => {
                  this.visible = false;
                  this.$emit("refreshDataList");
                },
              });
            })
            .catch(() => {});
        });
      },
      1000,
      { leading: true, trailing: false }
    ),
  },
};
</script>
